<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:23 PM
 *
 * This file controls the Widget Options for the Dimbal Software Poll Widgets
 *
 */
class DSCF_DSF_SupportForums_AddThreadButtonWidget extends WP_Widget {

    public static $displayOptions = array(
        1=>'button_text'
    );

    public function __construct() {
        // widget actual processes
        parent::__construct(
            'DSCF_DSF_SupportForums_AddThreadButtonWidget', // Base ID
            'Support Forums Add Thread Button', // Name
            array( 'description' => __( 'Add a button to take users to the Add Forum Thread page.', 'text_domain' ), ) // Args
        );
    }

    public function form( $instance ) {
        // outputs the options form on admin
        $title = __( 'Add Support Forum Thread' );
        $buttonText = __( 'Add New Thread' );
        if ( $instance ) {
            $title = esc_attr( $instance['title'] );
            $buttonText = esc_attr( $instance['button_text'] );
        }

        ?>
        <p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
        <input class="widefat" id="<?=($this->get_field_id( 'title' ))?>" name="<?=($this->get_field_name( 'title' ))?>" type="text" value="<?=($title)?>" />

        <label for="<?php echo $this->get_field_id( 'button_text' ); ?>"><?php _e( 'Button Text:' ); ?></label>
        <input class="widefat" id="<?=($this->get_field_id( 'button_text' ))?>" name="<?=($this->get_field_name( 'button_text' ))?>" type="text" value="<?=($buttonText)?>" />
        </p>
    <?php
    }

    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        $title = (array_key_exists('title',$new_instance))?$new_instance['title']:"";
        $instance['title'] = strip_tags($title);
        $title = (array_key_exists('button_text',$new_instance))?$new_instance['button_text']:"Add New Thread";
        $instance['button_text'] = strip_tags($title);
        return $instance;
    }

    public function widget( $args, $instance ) {
        // outputs the content of the widget

        // Make sure the framework is enabled (this will prevent the widget from display entirely)
        if(!DSCF_DSF_Utilities::isPluginEnabled()){
            return;
        }

        $buttonText = $instance['button_text'];

        // Before the widget
        echo $args['before_widget'];

        // Title information
        if ( ! empty( $instance['title'] ) ) {
            echo $args['before_title'];
            echo esc_html( $instance['title'] );
            echo $args['after_title'];
        }

        // Html for List Display
        echo '<a href="'.DSCF_DSF_SupportForums_Main::getAddThreadUrl().'"><button>'.$buttonText.'</button></a>';

        // After the widget
        echo $args['after_widget'];

    }
}
