<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:23 PM
 *
 * This file controls the Widget Options for the Dimbal Software Poll Widgets
 *
 */
class DSCF_DSF_SupportForums_CategoriesWidget extends WP_Widget {

    public static $displayOptions = array(
        1=>'count'
    );

    public function __construct() {
        // widget actual processes
        parent::__construct(
            'DSCF_DSF_SupportForums_CategoriesWidget', // Base ID
            'Support Forums Category List', // Name
            array( 'description' => __( 'Display a list of Support Forum Categories.', 'text_domain' ), ) // Args
        );
    }

    public function form( $instance ) {
        // outputs the options form on admin
        if ( $instance ) {
            $title = esc_attr( $instance['title'] );
        }
        else {
            $title = __( 'Support Forum Categories' );
        }

        ?>
        <p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
        <input class="widefat" id="<?=($this->get_field_id( 'title' ))?>" name="<?=($this->get_field_name( 'title' ))?>" type="text" value="<?=($title)?>" />
        </p>
    <?php
    }

    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        $title = (array_key_exists('title',$new_instance))?$new_instance['title']:"";
        $instance['title'] = strip_tags($title);

        return $instance;
    }

    public function widget( $args, $instance ) {
        // outputs the content of the widget

        // Make sure the framework is enabled (this will prevent the widget from display entirely)
        if(!DSCF_DSF_Utilities::isPluginEnabled()){
            return;
        }

        // Before the widget
        echo $args['before_widget'];

        // Title information
        if ( ! empty( $instance['title'] ) ) {
            echo $args['before_title'];
            echo esc_html( $instance['title'] );
            echo $args['after_title'];
        }

        $terms = get_terms( array(
            'taxonomy' => DSCF_DSF_SupportForums_Thread::KEYNAME_CATEGORY,
            'hide_empty' => true,
        ) );

        // Html for List Display
        if(!empty($terms)){
            echo '<div class="widget_categories"><ul>';
            foreach($terms as $term){
                ?>
                <li><a href="<?=(get_term_link($term))?>"><?=($term->name)?></a></li>
                <?php
            }
            echo '</ul></div>';
        }

        // After the widget
        echo $args['after_widget'];

    }
}
