<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:26 PM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DSF_SupportForums_Comment extends DSCF_DSF_StandardObjectRecord{

    public $threadId=0;					// The ID of the forum this comment is assigned to
    public $userId=0;
    public $comments="";				    // The comment text
    public $attachmentIds = array();	// An array of attachment IDs if needed

    public $approved=0;

    const TABLE_NAME = "comments";

    const STATE_UNAPPROVED = 0;
    const STATE_APPROVED = 1;

    public function __construct(){

        global $wpdb;
        $table_name = self::getTableName();

        //Pass it to the parent to setup some common items
        $this->create();

        //Save in the DB
        try{
            $wpdb->insert(
                $table_name,
                array(
                    'blogId' => $this->blogId,
                    'threadId' => $this->threadId,
                    'approved' => $this->approved,
                    'data' => self::pack($this)
                ),
                array(
                    '%d',
                    '%d',
                    '%d',
                    '%s'
                )
            );
        }catch(Exception $e){
            //DSCF_DSF_Utilities::logMessage('Error creating Poll: '.$e->getMessage());
            return false;
        }

        //Get the ID of the inserted row and save it back to the object
        try{
            $this->id = $wpdb->insert_id;
            $this->save();
        }catch(Exception $e){
            //DSCF_DSF_Utilities::logMessage('Error creating Poll: '.$e->getMessage());
            return false;
        }

        //Return the object
        return $this;
    }

    public function save(){
        global $wpdb;
        $table_name = self::getTableName();
        $this->setLastModified();
        try{
            $wpdb->update(
                $table_name,
                array(
                    'threadId'=>$this->threadId,
                    'approved' => $this->approved,
                    'data' => self::pack($this)
                ),
                array( 'ID' => $this->id ),
                array(
                    '%d',
                    '%d',
                    '%s'
                ),
                array( '%d' )
            );
        }catch(Exception $e){
            //DSCF_DSF_Utilities::logMessage('Error saving Object: '.$e->getMessage());
            return false;
        }
        return true;
    }

    // Controlled by Parent Class
    //public static function getTableName(){}

    // Controlled by Parent Class
    //public static function get($id){}

    // Controlled by Parent Class
    //public static function getAll($start=0,$limit=500){}

    // Controlled by Parent Class
    //public static function deleteById($id){}

    /*
    * A function to retrieve all objects by Quiz ID,
    */
    public static function getAllByThreadId($threadId, $start=0, $limit=5000){

        // Setup the variables
        global $wpdb;
        $tableName = static::getTableName();

        // Query the Data
        $sql = $wpdb->prepare(
            "
            SELECT * FROM $tableName
            WHERE blogId=%d
            AND threadId=%d
            ORDER BY id ASC
            LIMIT %d,%d
            ",
            get_current_blog_id(),
            $threadId,
            $start,
            $limit
        );

        return self::getMultipleBySql($sql);
    }

    public static function getFirstByThreadId(){

    }

    /*
    * A function to retrieve the count of all comments by a single thread id,
    */
    public static function getCountByThreadId($threadId){

        // Setup the variables
        global $wpdb;
        $tableName = static::getTableName();

        // Query the Data
        $sql = $wpdb->prepare(
            "
            SELECT count(*) as count FROM $tableName
            WHERE blogId=%d
            AND threadId=%d
            ",
            get_current_blog_id(),
            $threadId
        );

        return self::getCountBySql($sql);
    }

    public static function getAllUnapproved($start=0, $limit=5000){

        // Setup the variables
        global $wpdb;
        $tableName = static::getTableName();

        // Query the Data
        $sql = $wpdb->prepare(
            "
            SELECT * FROM $tableName
            WHERE blogId=%d
            AND approved=0
            ORDER BY id ASC
            LIMIT %d,%d
            ",
            get_current_blog_id(),
            $start,
            $limit
        );

        return self::getMultipleBySql($sql);
    }

    public static function editorBuildOptions($object){

        $query_args = array(
            'numberposts'=>500,
            'post_status' => array('publish','draft'),
            'post_type'  => DSCF_DSF_SupportForums_Thread::KEYNAME,
        );
        $threads = get_posts($query_args);
        $threadsArray = DSCF_DSF_StandardObjectRecord::getBasicArrayFromObjects($threads, 'post_title', 'ID');

        $options=array();
        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Basic Properties',
        );
        $options[]=array(
            'title'=>'ID',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>'id',
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT_READONLY,
            'value'=>($object)?$object->id:'',
            'help'=>''
        );
        $options[]=array(
            'title'=>'Assigned Thread',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>'threadId',
            'formType'=>DSCF_DSF_StandardEditor::ET_MENU_KEY,
            'formOptions'=>$threadsArray,
            'value'=>($object)?$object->threadId:0,
            'help'=>'The Thread this comment is assigned to'
        );
        $options[]=array(
            'title'=>'User ID',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>'userId',
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT,
            'value'=>($object)?$object->userId:0,
            'help'=>'The User ID that submitted this comment'
        );
        $options[]=array(
            'title'=>'Approval',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>'approved',
            'formType'=>DSCF_DSF_StandardEditor::ET_MENU_KEY,
            'formOptions'=>array(DSCF_DSF_SupportForums_Comment::STATE_UNAPPROVED=>'unapproved', DSCF_DSF_SupportForums_Comment::STATE_APPROVED=>'approved'),
            'value'=>($object)?$object->approved:0,
            'help'=>'Whether this comment has been approved or not.'
        );
        $options[]=array(
            'title'=>'Comments',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>'comments',
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>($object)?$object->comments:'',
            'help'=>'The comment content.',
        );
        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Attachments',
        );
        $options[]=array(
            'title'=>'Attachments',
            'objectType'=>DSCF_DSF_StandardEditor::OT_ARRAY,
            'objectName'=>'attachmentIds',
            'formType'=>DSCF_DSF_StandardEditor::ET_MEDIA_LIBRARY_MULTIPLE,
            'value'=>($object)?$object->attachmentIds:array(),
            'help'=>'Attachments submitted onto this comment.',
        );
        return $options;
    }

    public static function managerBuildOptions($objects){

        $query_args = array(
            'numberposts'=>500,
            'post_status' => array('publish','draft'),
            'post_type'  => DSCF_DSF_SupportForums_Thread::KEYNAME,
        );
        $threads = get_posts($query_args);
        $threadsArray = DSCF_DSF_StandardObjectRecord::getBasicArrayFromObjects($threads, 'post_title', 'ID');

        //DSCF_DSF_Utilities::logMessage("Comments: ".print_r($objects, true));

        $rows = array();
        foreach($objects as $object){

            if(empty($object)){
                continue;
            }

            $threadTitle = '';
            if(array_key_exists($object->threadId, $threadsArray)){
                $threadTitle = $threadsArray[$object->threadId];
            }

            $row = array();
            $row[] = array(
                'title'=>'ID',
                'content'=>$object->id,
            );
            $row[] = array(
                'title'=>'Edit',
                'url'=>DSCF_DSF_Utilities::getPageUrl(DSCF_DSF_SupportForums_Main::PAGE_COMMENTS, array('id'=>$object->id)),
                'image'=>WPDEVHUB_CONST_DSF_URL_IMAGES.'/page_edit.png',
                'image_tooltip'=>'Edit Comment',
            );
            $row[] = array(
                'title'=>'Thread',
                'content'=>$threadTitle,
            );
            $approvalImage = WPDEVHUB_CONST_DSF_URL_IMAGES.'/cross-bw.png';
            if($object->approved){
                $approvalImage = WPDEVHUB_CONST_DSF_URL_IMAGES.'/tick.png';
            }
            $row[] = array(
                'title'=>'Approved',
                'content'=>'<img src="'.$approvalImage.'" />',
            );
            $row[] = array(
                'title'=>'Comments',
                'content'=>DSCF_DSF_SupportForums_Comment::getCommentHtml($object),
                'style'=>'width:50%;'
            );
            $row[] = array(
                'title'=>'Delete',
                'url'=>DSCF_DSF_Utilities::getPageUrl(DSCF_DSF_SupportForums_Main::PAGE_COMMENTS, array('delete'=>1,'id'=>$object->id)),
                'image'=>WPDEVHUB_CONST_DSF_URL_IMAGES.'/delete.png',
                'image_tooltip'=>'Delete Comment',
            );
            $rows[]=$row;
        }
        return $rows;
    }

    public function exportForEditorDisplay(){
        $createdTime = DSCF_DSF_StandardObjectRecord::formatDateTime($this->createdDate);
        $userString = "annonymous";
        $user = get_userdata($this->userId);
        if(!empty($user)){
            $userString = $user->user_login;
        }

        $transfer = array(
            "approved",
            "attachmentIds",
            "comments",
            "id",
            "threadId",
            "userId",
        );

        $object = new stdClass();
        foreach($transfer as $key){
            $object->$key = $this->$key;
        }

        $object->userString = $userString;
        $object->dateString = $createdTime;

        return $object;

    }

    /*
     * Essentially does the same as the filter "the_contents" however we don't do it all
     * For example - we do the auto p add - but not the short code processing
     * In the future we can consider these as options in the settings pane
     */
    public static function getCommentHtml($comment){
        $html = wpautop($comment->comments);
        return $html;
    }


    public static function ajaxEditComment(){

        DSCF_DSF_Utilities::logMessage("Inside ajaxEditComment");

        $ac = DSCF_DSF_Utilities::getRequestVarIfExists('ac');

        $response = array();

        switch($ac){
            case 1:
                // Add a new comment
                DSCF_DSF_Utilities::logMessage("AJAX Adding a new comment");
                $text = DSCF_DSF_Utilities::getRequestVarIfExists('comments');
                DSCF_DSF_Utilities::logMessage("Raw TEXT: ".print_r($text, true));
                $text = stripslashes($text);

                DSCF_DSF_Utilities::logMessage("Raw TEXT - Step 1: ".print_r($text, true));
                $threadId = DSCF_DSF_Utilities::getRequestVarIfExists('threadId');
                $elemId = DSCF_DSF_Utilities::getRequestVarIfExists('elemId');
                $response['elemId'] = $elemId;

                DSCF_DSF_Utilities::logMessage("Data threadId[$threadId] elemId[$elemId] text[$text]");

                if(!empty($text)){
                    $userObject = wp_get_current_user();
                    if(empty($userObject) || empty($userObject->ID)){
                        DSCF_DSF_Utilities::logMessage("Cannot create Comment. Could not get logged in User.");
                        $response['error']="Invalid user";
                    }else{

                        $comment = new DSCF_DSF_SupportForums_Comment();
                        $comment->comments = $text;
                        $comment->threadId = $threadId;
                        $comment->userId = $userObject->ID;
                        $comment->approved = true;
                        $comment->save();

                        $response['commentId']=$comment->id;
                        $response['commentObject']=$comment->exportForEditorDisplay();
                        $response['code']=200;
                        $response['message']="Comment created successfully.";

                    }
                }else{
                    $response['error']="Invalid comment text";
                }

                break;
            case 2:
                // Edit the text of an existing comment
                $commentId = DSCF_DSF_Utilities::getRequestVarIfExists('commentId');
                $response['commentId']=$commentId;
                if(!empty($commentId)){
                    $comment = DSCF_DSF_SupportForums_Comment::get($commentId);
                    if(!empty($comment)){

                        $text = DSCF_DSF_Utilities::getRequestVarIfExists('comments');
                        if(!empty($text)){

                            $comment->comments = $text;
                            $comment->save();

                            $response['commentObject']=$comment->exportForEditorDisplay();
                            $response['code']=200;
                            $response['message']="Comment [".$commentId."] updated successfully.";

                        }else{
                            $response['error']="Invalid Comment Text Specified";
                        }

                    }else{
                        $response['error']="Invalid Comment ID Specified";
                    }

                }else{

                    $response['error']="No Comment ID Specified";
                }


                break;
            case 3:
                // Change approval of an existing comment
                $commentId = DSCF_DSF_Utilities::getRequestVarIfExists('commentId');
                $response['commentId']=$commentId;
                if(!empty($commentId)){
                    $comment = DSCF_DSF_SupportForums_Comment::get($commentId);
                    if(!empty($comment)){

                        $approved = DSCF_DSF_Utilities::getRequestVarIfExists('approved');
                        if(empty($approved)){
                            // Comment is not approved
                            $comment->approved = false;
                            $response['message']="Comment [".$commentId."] marked as unapproved.";
                        }else{
                            // Comment is approved
                            $comment->approved = true;
                            $response['message']="Comment [".$commentId."] marked as approved.";

                            // Check thread status
                            $count = DSCF_DSF_SupportForums_Comment::getCountByThreadId($comment->threadId);
                            if($count <= 1){
                                // First comment to be published - make sure the thread is published as well
                                $thread = array(
                                    'ID'           => $comment->threadId,
                                    'post_status'   => 'publish',
                                );
                                wp_update_post( $thread );
                            }

                        };
                        $response['approved']=$comment->approved;
                        $comment->save();
                        $response['code']=200;


                    }else{
                        $response['error']="Invalid Comment ID Specified";
                    }

                }else{

                    $response['error']="No Comment ID Specified";
                }
                break;
            case 4:
                // Delete an existing comment
                $commentId = DSCF_DSF_Utilities::getRequestVarIfExists('commentId');
                $response['commentId']=$commentId;
                if(!empty($commentId)){
                    $comment = DSCF_DSF_SupportForums_Comment::get($commentId);
                    if(!empty($comment)){

                        DSCF_DSF_SupportForums_Comment::deleteById($commentId);
                        $response['code']=200;
                        $response['message']="Comment [".$commentId."] deleted.";

                    }else{
                        $response['error']="Invalid Comment ID Specified";
                    }

                }else{

                    $response['error']="No Comment ID Specified";
                }
                break;
        }

        DSCF_DSF_Utilities::logMessage("Response: ".print_r($response, true));

        return $response;

    }

    public function isApproved(){
        return ($this->approved);
    }



}
