<?php
/**
 * Created by JetBrains PhpStorm.
 * User: admin
 * Date: 3/21/17
 * Time: 3:46 PM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DSF_SupportForums_CommentsMetaBox extends DSCF_DSF_StandardMetaBox{

    const KEYNAME = "dsf_comments";
    const TITLE = "Comments";
    const SCREEN = DSCF_DSF_SupportForums_Thread::KEYNAME;

    public static function renderCustom( $post ){


        DSCF_DSF_Utilities::logMessage("Inside RENDER routine for CommentsMetaBox.");

        //DSCF_DSF_SupportForums_Main::addActionEnqueueScripts();

        // Get the existing comments for this post
        $comments = DSCF_DSF_SupportForums_Comment::getAllByThreadId($post->ID);

        // Validate as an array
        if(empty($comments) || !is_array($comments)){
            $comments = array();
        }

        $html = '';

        $commentObjects = array();
        if(!empty($comments)){
            foreach($comments as $commentObject){
                // The "$value" should be an Object representing an item
                // Validate instance type
                if(is_a($commentObject, 'DSCF_DSF_SupportForums_Comment')){
                    $commentObjects[] = $commentObject->exportForEditorDisplay();
                }

            }
        }


        $html .= '<div id="addNewComment">';


        $html .= wp_editor("", "addNewCommentText", array('textarea_name'=>'comments'));

        $html .= '<div><button class="button" type="submit">Add New Comment</button></div>';
        $html .= '</div>';

        $html .= '<br /><br />';
        $html .= '<p>Existing Comments:</p>';
        $html .= '<hr />';

        $html .= '<table class="widfat striped dsf-admin-table"><tbody>';

        $isOdd = true;

        if(!empty($commentObjects) && is_array($commentObjects)){
            foreach($commentObjects as $commentObject){

                $elemId = "DSF_comment_".$commentObject->id;

                $rowStyle = "even thread-even";
                if($isOdd){
                    $rowStyle = "odd thread-odd alt thread-alt";
                    $isOdd = false;
                }else{
                    $isOdd = true;
                }

                $approvalHtml = '';
                // TODO - CSS Background color isn't applying because of an order of operations... Table backgrounds take precendent
                if($commentObject->approved){
                    $approvalHtml = '<a id="'.$elemId.'_approval_link" href="javascript:DSCF_DSF_Forums_Admin.changeApproval('.$commentObject->id.', 0);">remove approval</a>';
                }else{
                    $approvalHtml = '<a id="'.$elemId.'_approval_link" href="javascript:DSCF_DSF_Forums_Admin.changeApproval('.$commentObject->id.', 1);">approve</a>';
                    $rowStyle = 'dsf-color-background-warning '.$rowStyle;
                }

                $html .= '<tr id="'.$elemId.'" class="byuser '.$rowStyle.'">';

                $html .= '<td class="dsf-width-25per dsf-padding-soft">';

                $html .= 'Submitted on '.$commentObject->dateString;
                $html .= '<br />by user ['.$commentObject->userString.']';
                $html .= '<div class="dsf-div-table">';
                    $html .= '<div class="dsf-div-table-cell">';
                    $html .= '<a href="admin.php?page=wpdevhub-dsf-comments&id='.$commentObject->id.'">edit</a>';
                    $html .= ' | ';
                    $html .= $approvalHtml;
                    $html .= '</div>';
                    $html .= '<div class="dsf-div-table-cell dsf-align-right">';
                    $html .= '<a href="javascript:DSCF_DSF_Forums_Admin.deleteComment('.$commentObject->id.');">delete</a>';
                    $html .= '</div>';
                $html .= '</div>';
                $html .= '</td>';

                $html .= '<td class="dsf-padding-soft">';
                $html .= DSCF_DSF_SupportForums_Comment::getCommentHtml($commentObject);
                $html .= '</td>';

                $html .= '</tr>';

            }
        }else{
            // Empty Question List
            $html .= '<tr><td><p>No Comments on File.</p></td></tr>';
        }


        $html .= '</tbody></table>';


        echo $html;

    }

    public static function saveCustom( $post_id ){

        // If data is here it means we are saving a new comment

        //DSCF_DSF_Utilities::logMessage("Inside SAVE routine for CommentsMetaBox.");

        $text = DSCF_DSF_Utilities::getRequestVarIfExists('comments');
        if(!empty($text)){
            $userObject = wp_get_current_user();
            if(empty($userObject) || empty($userObject->ID)){
                DSCF_DSF_Utilities::logMessage("Cannot create Comment. Could not get logged in User.");
            }else{

                // Clean up the submitted text
                $text = stripslashes($text);
                $text = html_entity_decode($text);

                $comment = new DSCF_DSF_SupportForums_Comment();
                $comment->comments = $text;
                $comment->threadId = $post_id;
                $comment->userId = $userObject->ID;
                $comment->approved = true;
                $comment->save();
            }
        }else{
            DSCF_DSF_Utilities::logMessage("Cannot create Comment. Comment Text Empty.");
        }

    }

}
