<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:26 PM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DSF_SupportForums_Main extends DSCF_DSF_StandardMain{

    public static $classname = "DSCF_DSF_SupportForums_Main";

    const CURRENT_VERSION = 4;

    const PAGE_HOME = "home";
    const PAGE_COMMENTS = "comments";
    const PAGE_PENDING_COMMENTS = "pending-comments";
    const PAGE_SETTINGS = "settings";
    const PAGE_TOOLS = "tools";

    const SC_ID_HOMEPAGE = 1;
    const SC_ID_START_THREAD_PROMPT = 2;
    const SC_ID_DISPLAY_THREAD = 3;
    const SC_ID_DISPLAY_CATEGORY = 4;

    const SETTINGS_SLUG_BASE = "vp_slug_base";
    const SLUG_BASE = "forums";

    const SETTINGS_THREAD_CONTENT_BEFORE = "thread_content_before";
    const SETTINGS_THREAD_CONTENT_AFTER = "thread_content_after";
    const SETTINGS_COMMENT_CONTENT_BEFORE = "comment_content_before";
    const SETTINGS_COMMENT_CONTENT_AFTER = "comment_content_after";

    const SETTINGS_NOTIFICATIONS = "notifications";
    const SETTINGS_ALLOW_EMPTY_CONTENT = "allow_empty_content";

    const SETTINGS_REQUIRE_USER_TO_READ_THREAD = "require_user_to_read_thread";
    const SETTINGS_REQUIRE_USER_TO_CREATE_THREAD = "require_user_to_create_thread";
    const SETTINGS_REQUIRE_USER_TO_READ_COMMENT = "require_user_to_read_comment";
    const SETTINGS_REQUIRE_USER_TO_CREATE_COMMENT = "require_user_to_create_comment";

    const SETTINGS_THREAD_VALIDATION_ROUTINE = "thread_validation_routine";
    const SETTINGS_DEFAULT_THREAD_STATUS = "default_thread_status";
    const SETTINGS_DEFAULT_COMMENT_STATUS = "default_comment_status";

    const SETTINGS_ADD_THREAD_PROMPT = "add_thread_prompt";
    const SETTINGS_ADD_THREAD_CONFIRMATION = "add_thread_confirmation";

    const SETTINGS_USER_CONTENT_MAX_PER_PERIOD = "uc_max_per_period";
    const SETTINGS_USER_CONTENT_PERIOD_LENGTH = "uc_period_length";

    const USER_META_CONTENT_HISTORY = "DSCF_DSF_content_history";

    const ADD_THREAD_SLUG = 'add-thread';

    const DEFAULT_THREAD_AUTO_CLOSE_DAYS = 365;


    /*
    * WordPress Action Hook for init :: Generally the first action available to the Plugins
    */
    public static function wpActionInit(){
        parent::wpActionInit();

        // Add CSS and JS Resources
        //self::addResourceToEnqueue($name, $url, $type);
        self::addResourceToEnqueue(WPDEVHUB_CONST_DSF_SLUG.'-dsf-admin-js', WPDEVHUB_CONST_DSF_URL.'/js/wpdevhub-dsf-admin.js', self::ERT_ADMIN_SCRIPT);
        //self::addResourceToEnqueue(WPDEVHUB_CONST_DSF_SLUG.'-dsf-css', WPDEVHUB_CONST_DSF_URL.'/css/wpdevhub-dsf.css', self::ERT_PUBLIC_CSS);
        //self::addResourceToEnqueue(WPDEVHUB_CONST_DSF_SLUG.'jquery-time-picker', WPDEVHUB_CONST_DSF_URL.'/js/jquery-ui-timepicker-addon.min.js', self::ERT_ADMIN_SCRIPT);

        // Add AJAX Handlers
        //self::addAjaxMapping($name, $callable, $type);
        self::addAjaxMapping('WPDEVHUB_CONST_DSF_SLUG-admin-edit-comment', array('DSCF_DSF_SupportForums_Comment','ajaxEditComment'), self::AMT_ADMIN);

        // Add CRON Hooks
        //self::addCronHandler($name, $callable, $schedule);

        // Add Widgets
        //self::addWidget($classname);
        self::addWidget( 'DSCF_DSF_SupportForums_RecentPostsWidget' );
        self::addWidget( 'DSCF_DSF_SupportForums_CategoriesWidget' );
        self::addWidget( 'DSCF_DSF_SupportForums_AddThreadButtonWidget' );
        self::addWidget( 'DSCF_DSF_SupportForums_AddThreadFormWidget' );

        // Add ShortCode
        self::addShortcode(self::SC_ID_HOMEPAGE, array('DSCF_DSF_SupportForums_Main','shortcodeHandlerHomePageDisplay'));
        //self::addShortcode(self::SC_ID_START_THREAD_PROMPT, array('DSCF_DSF_SupportForums_Main','shortcodeHandlerStartThreadPrompt'));
        //self::addShortcode(self::SC_ID_DISPLAY_THREAD, array('DSCF_DSF_SupportForums_Main','shortcodeHandlerHomePageDisplay'));
        //self::addShortcode(self::SC_ID_DISPLAY_CATEGORY, array('DSCF_DSF_SupportForums_Main','shortcodeHandlerHomePageDisplay'));

        // Add Custom post tupes
        self::addCustomPostType( DSCF_DSF_SupportForums_Thread::KEYNAME , 'DSCF_DSF_SupportForums_Thread' );

        // Add MetaBox
        self::addMetaBox( 'DSCF_DSF_SupportForums_CommentsMetaBox' );

        // Random Filters, etc
        add_filter( 'preprocess_comment' , array( 'DSCF_DSF_SupportForums_Main' , 'wpFilterPreprocessComment') );
        add_filter( 'manage_' . strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME) . '_posts_columns' , array( 'DSCF_DSF_SupportForums_Thread' , 'wpFilterManagePostsColumn'), 10 );
        add_filter( 'manage_' . strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME) . '_posts_custom_column' , array( 'DSCF_DSF_SupportForums_Thread' , 'wpFilterManagePostsCustomColumn'), 10, 2);

        // Migrate the old CPT Names and Keys
        //DSCF_DSF_Utilities::migratePostTypesIfNeeded("dscf_dsf_sft", DSCF_DSF_SupportForums_Thread::KEYNAME);
        //DSCF_DSF_Utilities::migrateTaxonomyTypesIfNeeded("dscf_dsf_sft_category", DSCF_DSF_SupportForums_Thread::KEYNAME_CATEGORY);
        //DSCF_DSF_Utilities::migrateTaxonomyTypesIfNeeded("dscf_dsf_sft_tag", DSCF_DSF_SupportForums_Thread::KEYNAME_TAG);
        //DSCF_DSF_Utilities::migrateMetaBoxDataIfNeeded("comments", DSCF_DSF_SupportForums_CommentsMetaBox::KEYNAME);

    }

    public static function wpActionAdminMenu(){

        $dscf = strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME);

        //add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
        add_menu_page( 'Dimbal Support Forums', WPDEVHUB_CONST_DSF_PLUGIN_TITLE, 'manage_options', $dscf, array('DSCF_DSF_Utilities','renderPage'), '', 25 );

        //add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);
        //add_submenu_page( DSCF_DSF_Utilities::buildPageSlug(self::PAGE_HOME), 'Threads', 'Threads', 'manage_options', 'edit.php?post_type='.$dscf, array('DSCF_DSF_Utilities','renderPage'));
        //add_submenu_page( DSCF_DSF_Utilities::buildPageSlug(self::PAGE_HOME), 'Categories', 'Categories', 'manage_options', 'edit-tags.php?taxonomy='.DSCF_DSF_SupportForums_Thread::KEYNAME_CATEGORY.'&post_type='.strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME));

        add_submenu_page( $dscf, 'Add New Thread', 'Add New Thread', 'manage_options', 'post-new.php?post_type='.strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME));
        add_submenu_page( $dscf, 'Pending Comments', 'Pending Comments', 'manage_options', DSCF_DSF_Utilities::buildPageSlug(self::PAGE_PENDING_COMMENTS), array('DSCF_DSF_Utilities','renderPage'));
        add_submenu_page( $dscf, 'All Comments', 'Comments', 'manage_options', DSCF_DSF_Utilities::buildPageSlug(self::PAGE_COMMENTS), array('DSCF_DSF_Utilities','renderPage'));
        add_submenu_page( $dscf, 'Categories', 'Categories', 'manage_options', 'edit-tags.php?taxonomy='.DSCF_DSF_SupportForums_Thread::KEYNAME_CATEGORY.'&post_type='.strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME));
        add_submenu_page( $dscf, 'Tags', 'Tags', 'manage_options', 'edit-tags.php?taxonomy='.DSCF_DSF_SupportForums_Thread::KEYNAME_TAG.'&post_type='.strtolower(DSCF_DSF_SupportForums_Thread::KEYNAME));
        add_submenu_page( $dscf, 'Settings', 'Settings', 'manage_options', DSCF_DSF_Utilities::buildPageSlug(self::PAGE_SETTINGS), array('DSCF_DSF_Utilities','renderPage'));

        //http://localhost:8888/SampleWordpressSite/wp-admin/post-new.php?post_type=dscf_dsf_sft
        //http://localhost:8888/SampleWordpressSite/wp-admin/edit-tags.php?taxonomy=DSCF_DSF_DSF_sft_category&post_type=dscf_dsf_sft
        //http://localhost:8888/SampleWordpressSite/wp-admin/edit-tags.php?taxonomy=DSCF_DSF_DSF_sft_tag&post_type=dscf_dsf_sft

        // Taking the tools page out until we have more tools then just adding sample data
        //add_submenu_page( 'edit.php?post_type='.$dscf, 'Tools', 'Tools', 'manage_options', DSCF_DSF_Utilities::buildPageSlug(self::PAGE_TOOLS), array('DSCF_DSF_Utilities','renderPage'));

        //add_submenu_page( 'fake-slug-does-not-exist', 'Preview', 'Preview', 'manage_options', DSCF_DSF_Utilities::buildPageSlug(self::PAGE_PREVIEW), array('DSCF_DSF_Utilities','renderPage'));
    }

    // Database Install Routine
    public static function installDatabase(){
        global $wpdb;

        // Get the DB CharSet
        $charset_collate = $wpdb->get_charset_collate();

        $sql = "";

        $tt_table_name = DSCF_DSF_SupportForums_Comment::getTableName();
        $sql .= "
            CREATE TABLE $tt_table_name (
                id int(11) NOT NULL AUTO_INCREMENT,
                blogId BIGINT(20),
                threadId BIGINT(20),
                approved BIGINT(20),
                data mediumblob,
                UNIQUE KEY id (id)
            ) $charset_collate;
            ";

        // Run the SQL
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );

        // Add an option to store the version number
        add_option( DSCF_DSF_Utilities::buildDatabaseVersionString(), self::CURRENT_VERSION );
    }

    public static function buildSettingsEditorOptions($object=null){

        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Global Framework Settings',
        );

        $options[]=array(
            'title'=>'Plugin Enabled',
            'objectType'=>DSCF_DSF_StandardEditor::OT_BOOLEAN,
            'objectName'=>'plugin_enabled',
            'formType'=>DSCF_DSF_StandardEditor::ET_CHECKBOX,
            'value'=>(isset($object->plugin_enabled))?$object->plugin_enabled:true,
            'help'=>'True to enable the Plugin, False to disable it without uninstalling it.  If False, will prevent the display of all user facing threads, etc...  Use this feature to disable the plugin globally without having to uninstall it.'
        );
        $keyname = self::SETTINGS_SLUG_BASE;
        $options[]=array(
            'title'=>'Virtual Path',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT,
            'size'=>50,
            'value'=>(isset($object->$keyname))?$object->$keyname:self::SLUG_BASE,
            'help'=>'The virtual path off of '.site_url().' to house the forums.  Default Value: "'.self::SLUG_BASE.'"'
        );
        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Validations and Notifications',
        );
        $keyname = self::SETTINGS_ALLOW_EMPTY_CONTENT;
        $options[]=array(
            'title'=>'Allow Empty Content',
            'objectType'=>DSCF_DSF_StandardEditor::OT_BOOLEAN,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_CHECKBOX,
            'value'=>(isset($object->$keyname))?$object->$keyname:true,
            'help'=>'If enabled, will allow users to submit forum submissions with a title only.  If unchecked, users must submit a title and content.'
        );
        $userList = self::getUserMenuForNotificationSettings();
        $keyname = self::SETTINGS_NOTIFICATIONS;
        $options[]=array(
            'title'=>'New Content Notifications',
            'objectType'=>DSCF_DSF_StandardEditor::OT_ARRAY,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_CHECKBOX_GROUP,
            'formOptions'=>$userList,
            'value'=>(isset($object->$keyname))?$object->$keyname:array(),
            'help'=>'A list of users that should receive management notifications of new threads, new comments, etc.  User must be in the "administrator" or "editor" role.'
        );
        $keyname = self::SETTINGS_THREAD_VALIDATION_ROUTINE;
        $options[]=array(
            'title'=>'Create Thread - Custom Validation',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT,
            'value'=>(isset($object->$keyname))?$object->$keyname:"",
            'size'=>50,
            'help'=>'A function name to call whose output must return TRUE in order to allow the user to post a new Thread.  Useful when locking thread creation behind custom criteria.'
        );
        /*
        $keyname = self::SETTINGS_DEFAULT_THREAD_STATUS;
        $options[]=array(
            'title'=>'New Thread Visibility Status',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_MENU,
            'formOptions'=>array('draft','publish'),
            'value'=>(isset($object->$keyname))?$object->$keyname:"draft",
            'help'=>'The status that should be set for new forum threads.  If you want to immediately publish then choose "publish".  If you want to review submission before publishing then choose "draft".'
        );
        */
        $keyname = self::SETTINGS_DEFAULT_COMMENT_STATUS;
        $options[]=array(
            'title'=>'New Comment Approval Status',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_MENU_KEY,
            'formOptions'=>array(DSCF_DSF_SupportForums_Comment::STATE_UNAPPROVED=>'unapproved', DSCF_DSF_SupportForums_Comment::STATE_APPROVED=>'approved'),
            'value'=>(isset($object->$keyname))?$object->$keyname:DSCF_DSF_SupportForums_Comment::STATE_UNAPPROVED,
            'help'=>'Approval status for new comments.  Unapproved comments require manual approval.'
        );

        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Submission Throttling',
        );
        $keyname = self::SETTINGS_USER_CONTENT_MAX_PER_PERIOD;
        $options[]=array(
            'title'=>'Max Submissions Per Period',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT,
            'value'=>(isset($object->$keyname))?$object->$keyname:5,
            'size'=>10,
            'help'=>'The maximum number of submissions (comments and threads) accepted by a single user within a given period of time.  Example, 5 submissions within X number of seconds defined below.'
        );
        $keyname = self::SETTINGS_USER_CONTENT_PERIOD_LENGTH;
        $options[]=array(
            'title'=>'Period Length (seconds)',
            'objectType'=>DSCF_DSF_StandardEditor::OT_NUMERIC,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXT,
            'value'=>(isset($object->$keyname))?$object->$keyname:120,
            'size'=>10,
            'help'=>'The length of seconds that represents a single period of time.  Example, 120 for (2) minutes.'
        );

        $options[]=array(
            'rowType'=>'SectionHeader',
            'title'=>'Content Settings',
        );
        $keyname = self::SETTINGS_ADD_THREAD_PROMPT;
        $options[]=array(
            'title'=>'Add Thread Prompt',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'<p>Please use the form below to add a new thread to our forums.</p>',
            'help'=>'Content to include at the top of the Add Thread form.'
        );
        $keyname = self::SETTINGS_ADD_THREAD_CONFIRMATION;
        $options[]=array(
            'title'=>'Add Thread Confirmation',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'<p>Thank you for your submission.</p>',
            'help'=>'Content to include on the Confirmation page when a new thread has been added.'
        );
        /*
        $keyname = self::SETTINGS_THREAD_CONTENT_BEFORE;
        $options[]=array(
            'title'=>'Content Before Each Thread',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'',
            'help'=>'Content to include at the start of each thread.'
        );
        $keyname = self::SETTINGS_THREAD_CONTENT_AFTER;
        $options[]=array(
            'title'=>'Content After Each Thread',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'',
            'help'=>'Content to include at the end of each thread.'
        );
        $keyname = self::SETTINGS_COMMENT_CONTENT_BEFORE;
        $options[]=array(
            'title'=>'Content Before Each Comment',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'',
            'help'=>'Content to include before each individual comment is displayed.'
        );
        $keyname = self::SETTINGS_COMMENT_CONTENT_AFTER;
        $options[]=array(
            'title'=>'Content After Each Comment',
            'objectType'=>DSCF_DSF_StandardEditor::OT_STRING,
            'objectName'=>$keyname,
            'formType'=>DSCF_DSF_StandardEditor::ET_TEXTAREA_HTML,
            'value'=>(isset($object->$keyname))?$object->$keyname:'',
            'help'=>'Content to include after each individual comment is displayed.'
        );
        */

        return $options;

    }

    public static function buildSampleData(){

        $categoryCount=5;
        $threadCountLow=6;
        $threadCountHigh=10;
        $commentCountLow=0;
        $commentCountHigh=5;
        $userObject = wp_get_current_user();
        $categoryObjects = array();

        $postData = array(
            'post_author'   => $userObject->ID,
            'post_title'    => DSCF_DSF_Utilities::getRandomLoremIpsumTitle(),
            'post_content'  => 'content',
            'post_status'   => 'publish',           // Choose: publish, preview, future, draft, etc.
            'post_type'     => 'DSCF_DSF_thread',
            'meta_input'    => array(
                'is_sampled_data'   => true
            )

        );

        $time = current_time('mysql');
        $commentData = array(
            'comment_post_ID' => 0,
            'comment_author' => 'admin',
            'comment_author_email' => 'admin@admin.com',
            'comment_author_url' => 'http://',
            'comment_content' => 'content here',
            'comment_type' => '',
            'comment_parent' => 0,
            'user_id' => 1,
            'comment_author_IP' => '127.0.0.1',
            'comment_agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)',
            'comment_date' => $time,
            'comment_approved' => 1,
        );

        for($cat=0; $cat<$categoryCount; $cat++){

            $termString = DSCF_DSF_Utilities::getRandomLoremIpsumTitle();
            $categoryResponse = term_exists($termString, 'DSCF_DSF_category');
            if(empty($categoryResponse)){
                $categoryResponse = wp_insert_term(DSCF_DSF_Utilities::getRandomLoremIpsumTitle(), 'DSCF_DSF_category');
            }

            if(!empty($categoryResponse) && is_array($categoryResponse)){

                $threadCount = rand($threadCountLow, $threadCountHigh);
                for($i=0; $i<$threadCount; $i++){

                    $lineCount = rand(2, 5);
                    $postData['post_title'] = DSCF_DSF_Utilities::getRandomLoremIpsumTitle();
                    $postData['post_content'] = DSCF_DSF_Utilities::getRandomLoremIpsumParagraphs($lineCount);
                    $pid = wp_insert_post($postData);

                    // Set the category
                    wp_set_post_terms( $pid, $categoryResponse['term_id'], 'DSCF_DSF_category', true );

                    // Create comments
                    $commentCount = rand($commentCountLow, $commentCountHigh);
                    for($c=0; $c<$commentCount; $c++){
                        $lineCount = rand(1, 3);
                        $commentData['comment_post_ID'] = $pid;
                        $commentData['comment_content'] = DSCF_DSF_Utilities::getRandomLoremIpsumParagraphs($lineCount);
                        wp_insert_comment($commentData);
                    }

                }
            }else{
                DSCF_DSF_Utilities::logMessage("Error Creating Category: ".print_r($categoryResponse, true));
            }

        }

    }

    /*
     * The target url for adding a new thread or adding a new post
     */
    public static function getHomeUrl(){
        return self::getBaseUrl();
    }

    /*
     * The target url for adding a new thread or adding a new post
     */
    public static function getAddThreadUrl(){
        return self::getBaseUrl().'add-thread/';
    }

    /*
     * The target url for adding a new thread or adding a new post
     */
    public static function getAddThreadHandlerUrl(){
        return self::getBaseUrl().'add-thread-handler/';
    }

    /*
    * The target url for adding a new thread or adding a new post
    */
    public static function getAddCommentHandlerUrl(){
        return self::getBaseUrl().'add-comment-handler/';
    }

    /*
    * The target url for adding a new thread or adding a new post
    */
    public static function getAddContentConfirmationUrl(){
        return self::getBaseUrl().'add-content-confirmation/';
    }

    /*
    * The target url for adding a new thread or adding a new post
    */
    public static function getErrorHandlerUrl($errorCode){
        return self::getBaseUrl().'error/'.$errorCode.'/';
    }

    public static function shortcodeHandlerHomePageDisplay($atts){

        $html = '';

        // Get a list of all threads

        return $html;
    }

    public static function getUserMenuForNotificationSettings(){
        $users = get_users(array('role__in'=>array('administrator','editor'), 'fields'=>array('ID','display_name')));
        $users = DSCF_DSF_StandardObjectRecord::getBasicArrayFromObjects($users, 'display_name', 'ID');
        return $users;

    }

    public static function checkThreadValidation(){
        $threadValidation = DSCF_DSF_StandardSetting::getSetting(DSCF_DSF_SupportForums_Main::SETTINGS_THREAD_VALIDATION_ROUTINE);
        $threadValidation = trim(str_replace(array(")","(",";"), "", $threadValidation));
        if(empty($threadValidation)){
            // Nothing to check for
            return true;
        }
        if(!function_exists($threadValidation)){
            return true;
        }
        return call_user_func($threadValidation);
    }

    /*
     * Cleans and sanitizes a string whether from a text field or text area
     * https://codex.wordpress.org/Data_Validation#Input_Validation
     */
    public static function cleanAndSanitizeUserInput($string){
        $trustedHtmlTags = array();
        /*
        $trustedHtmlTags=array(
            'a' => array(
                'href' => array(),
                'title' => array()
            ),
            'br' => array(),
            'em' => array(),
            'strong' => array(),
            'img' => array(
                'src' => array(),
                'alt' => array()
            )
        );
        */
        $string = wp_kses($string, $trustedHtmlTags);             // Removes evil scripts and untrusted html
        $string = wp_rel_nofollow($string);     // Adds no follow to any links

        // This will prevent the display of valid HTML by adding slashes to any HTML tags
        $string = esc_attr($string);

        return $string;
    }

    public static function getUserContentHistory($userId){
        $userMeta = get_user_meta($userId, self::USER_META_CONTENT_HISTORY);
        //DSCF_DSF_Utilities::logMessage("Got Raw Meta: ".print_r($userMeta, true));
        $userHistory = array();
        if(!empty($userMeta) && is_array($userMeta) && array_key_exists(0, $userMeta)){
            $userHistory = $userMeta[0];
            if(empty($userHistory) || !is_array($userHistory)){
                $userHistory = array();
            }
        }
        //DSCF_DSF_Utilities::logMessage("Got History: ".print_r($userHistory, true));
        return $userHistory;
    }

    public static function canUserAddContent($userId){
        // Can only ad X content in Y seconds

        $count = 0;
        $threshold = time() - self::getThrottlingPeriodLength();
        $userHistory = self::getUserContentHistory($userId);
        if(!empty($userHistory) && is_array($userHistory)){
            foreach($userHistory as $key=>$value){
                if($value > $threshold){
                    $count++;
                }
            }
        }

        if($count >= self::getThrottlingMaxPerPeriod()){
            return false;
        }
        return true;

    }

    public static function addUserContentHistory($userId, $timestamp=null){

        if(empty($timestamp)){
            $timestamp=time();
        }

        $userHistory = self::getUserContentHistory($userId);
        $userHistory[] = $timestamp;

        $max = self::getThrottlingMaxPerPeriod();
        $start = 0 - $max;

        if(count($userHistory) > $max){
            $userHistory = array_slice($userHistory, $start, $max);    // Only keep the 5 highest elements
        }

        DSCF_DSF_Utilities::logMessage("Saving History: ".print_r($userHistory, true));

        $return = update_user_meta($userId, self::USER_META_CONTENT_HISTORY, $userHistory);
    }

    public static function wpFilterPreprocessComment($commentData){

        if(empty($commentData) || !is_array($commentData)){
            return $commentData;
        }

        if(!array_key_exists('comment_post_ID', $commentData)){
            return $commentData;
        }

        $postId = $commentData['comment_post_ID'];
        if(empty($postId)){
            return $commentData;
        }

        $post = get_post($postId);
        if(empty($post) || empty($post->post_type)){
            return $commentData;
        }

        if($post->post_type != DSCF_DSF_SupportForums_Thread::KEYNAME){
            return $commentData;
        }

        // At this point we should only be here if the post is a valid Forum Post

        // Send the notif of the comment data

    }

    /*
    * Virtual Page handler to display the form to add a new thread into a category
    */
    public static function getVirtualPagesAddThreadForCategory($params=array()){

        // Check to see if the Plugin is Active
        if(!DSCF_DSF_SupportForums_Main::isPluginEnabled()){
            wp_redirect( home_url() );
            exit;
        }

        // Enqueue Scripts
        DSCF_DSF_SupportForums_Main::wpActionEnqueueScripts();

        $categoryId = 0;
        if(!empty($params) && array_key_exists('category_slug', $params) && !empty($params['category_slug'])){
            $category = get_term_by('slug', $params['category_slug'], DSCF_DSF_SupportForums_Thread::KEYNAME.'_category');
            if(!empty($category)){
                $categoryId = $category->term_id;
            }
        }

        $html = '';

        $forumHomeUrl = DSCF_DSF_SupportForums_Main::getHomeUrl();
        $html .= '
            <p class="dsf-align-right">
                <a href="'.$forumHomeUrl.'">Forum Home</a>
            </p>
            ';

        $threadValidation = true;
        //$threadValidation = DSCF_DSF_SupportForums_Main::checkThreadValidation();
        if(!$threadValidation){
            $html .= '<p>Please <a href="'.wp_login_url( get_permalink() ).'" title="Login">Login</a> to create a thread.</p>';
        }else{

            $userObject = wp_get_current_user();
            if(empty($userObject) || empty($userObject->ID)){
                $html .= '<p>Please <a href="'.wp_login_url( get_permalink() ).'" title="Login">Login</a> to create a thread.</p>';
            }else{

                if(DSCF_DSF_SupportForums_Main::canUserAddContent($userObject->ID)){

                    $prompt = DSCF_DSF_StandardSetting::getSetting(self::SETTINGS_ADD_THREAD_PROMPT);
                    if(!empty($prompt)){
                        $html .= $prompt;
                    }

                    $html .= '
                        <form id="new_post" name="new_post" method="post" action="'.DSCF_DSF_SupportForums_Main::getAddThreadHandlerUrl().'">

                            <p><label for="title">Title:</label><br />
                            <input type="text" class="dsf-textfield" name="title" value="" placeholder="Thread Title" /></p>

                            <p><label for="Category">Category:</label><br />
                            '.wp_dropdown_categories( "show_option_none=-------&hide_empty=0&tab_index=4&echo=0&taxonomy=".DSCF_DSF_SupportForums_Thread::KEYNAME."_category&selected=".$categoryId ).'</p>


                            <p><label for="content">Content:</label><br />
                            <textarea name="content" class="dsf-textarea"></textarea></p>

                            <p><label for="tags">Tags:</label>
                            <input type="text" class="dsf-textfield" value="" tabindex="5" size="16" name="tags" id="tags" /></p>

                            <p><input type="submit" value="Add Thread" tabindex="6" id="submit" name="submit" /></p>

                            <input type="hidden" name="action" value="new_post" />
                            '.wp_nonce_field( 'new-post' ).'
                        </form>
                    ';

                }else{
                    $html .= '<p>Please slow down.  Only so many posts and comments can be made in such a short timeframe.</p>';
                }

            }

        }

        $details = array(
            'title'=>'Add New Thread',
            'content'=>$html
        );

        return $details;
    }

    public static function getVirtualPagesAddContentConfirmation($params=array()){

        // Check to see if the Plugin is Active
        if(!DSCF_DSF_SupportForums_Main::isPluginEnabled()){
            wp_redirect( home_url() );
            exit;
        }

        // Enqueue Scripts
        DSCF_DSF_SupportForums_Main::wpActionEnqueueScripts();

        $html = '';

        $prompt = DSCF_DSF_StandardSetting::getSetting(self::SETTINGS_ADD_THREAD_CONFIRMATION);
        if(!empty($prompt)){
            $html .= $prompt;
        }

        $extraButton = "";
        $threadId = DSCF_DSF_Utilities::getRequestVarIfExists("tid");
        if(!empty($threadId)){
            $thread = get_post($threadId);
            if(!empty($thread)){
                $extraButton = '<a href="'.get_permalink($threadId).'"><button>'.$thread->post_title.'</button></a>';
            }
        }

        $html .= '
            <p><a href="'.DSCF_DSF_SupportForums_Main::getHomeUrl().'"><button>Forums Home</button></a>'.$extraButton.'</p>
        ';

        $details = array(
            'title'=>'Content Submitted',
            'content'=>$html
        );

        return $details;

    }

    public static function getVirtualPagesErrorHandler($params=array()){

        // Check to see if the Plugin is Active
        if(!DSCF_DSF_SupportForums_Main::isPluginEnabled()){
            wp_redirect( home_url() );
            exit;
        }

        // Enqueue Scripts
        DSCF_DSF_SupportForums_Main::wpActionEnqueueScripts();

        $errorCode = 0;
        if(!empty($params) && array_key_exists('error_code', $params) && !empty($params['error_code'])){
            $errorCode = $params['error_code'];
        }

        $errorTitle = "";
        $errorContent = "";
        switch($errorCode){
            case 101:
                $errorTitle = "Malformed request";
                $errorContent = "There was an issue processing that request.  Please go back and try again.";
                break;
            case 102:
                $errorTitle = "Title is required";
                $errorContent = "Please include a title with your thread.";
                break;
            case 103:
                $errorTitle = "Content is required";
                $errorContent = "Please include a description with your thread.";
                break;
            case 104:
                $errorTitle = "User required";
                $errorContent = "A valid user account is required.  Please login first.";
                break;
            case 105:
                $errorTitle = "User throttling";
                $errorContent = "Please slow down between posts.  Too much content has been posted.";
                break;
            case 106:
                $errorTitle = "User validation failed";
                $errorContent = "Insufficient user privileges to post this content.";
                break;
            default:

                wp_redirect( home_url() );
                exit;

                break;
        }

        $errorContent .= '
            <p><a href="'.DSCF_DSF_SupportForums_Main::getHomeUrl().'"><button>Forums Home</button></a>&nbsp;<a href="'.DSCF_DSF_SupportForums_Main::getAddThreadUrl().'"><button>Add Thread</button></a></p>
        ';



        $details = array(
            'title'=>$errorTitle,
            'content'=>$errorContent
        );

        return $details;

    }



    public static function sendModeratorNotification($options=array(), $headers=array()){

        $defaultOptions = array(
            'subject'=>'Forum Moderation',
            'message'=>'A new support forum entry needs moderation',
        );
        $options = array_merge($defaultOptions, $options);

        $fromString = DSCF_DSF_Utilities::makeEmailAddressStringForHeaders(get_bloginfo('name'), get_bloginfo('admin_email'));
        //DSCF_DSF_Utilities::logMessage("From String: ".$fromString);
        $defaultHeaders = array(
            'Content-Type'=>'text/html; charset=UTF-8',
            'From'=>$fromString,
            'Reply-To'=>$fromString,
        );
        $headers = array_merge($defaultHeaders, $headers);
        $headerArray = array();
        foreach($headers as $k=>$v){
            $headerArray[] = $k.": ".$v;
        }

        if(empty($options['message'])){
            DSCF_DSF_Utilities::logMessage("Can't send moderator notification. Empty Message.");
            return;
        }

        if(empty($options['subject'])){
            DSCF_DSF_Utilities::logMessage("Can't send moderator notification. Empty Subject.");
            return;
        }

        $userIds = DSCF_DSF_StandardSetting::getSetting(self::SETTINGS_NOTIFICATIONS);
        if(empty($userIds) || !is_array($userIds)){
            DSCF_DSF_Utilities::logMessage("No moderators set - can't send moderator notification.");
            return;
        }

        //DSCF_DSF_Utilities::logMessage("User IDS to send Emails to: ".print_r($userIds, true));

        $users = get_users(array('include'=>$userIds));

        if(empty($users) || !is_array($users)){
            DSCF_DSF_Utilities::logMessage("No user accounts found - can't send moderator notification.");
            return;
        }

        foreach($users as $user){
            $to = DSCF_DSF_Utilities::makeEmailAddressStringForHeaders($user->display_name,$user->user_email);
            if(empty($to)){
                // Email did not pass validation
                DSCF_DSF_Utilities::logMessage("Email Address Failed Validation Email[".$user->user_email."]");
                continue;
            }

            // Send the email
            wp_mail($to, $options['subject'], $options['message'], $headerArray);
            DSCF_DSF_Utilities::logMessage("Email sent to [".$to."] Details:".print_r(array('OPTIONS'=>$options,'HEADERS'=>$headerArray), true));
        }

    }

    public static function getThrottlingMaxPerPeriod(){
        return DSCF_DSF_StandardSetting::getSetting(self::SETTINGS_USER_CONTENT_MAX_PER_PERIOD);
    }

    public static function getThrottlingPeriodLength(){
        return DSCF_DSF_StandardSetting::getSetting(self::SETTINGS_USER_CONTENT_PERIOD_LENGTH);
    }

}
