<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:23 PM
 *
 * This file controls the Widget Options for the Dimbal Software Poll Widgets
 *
 */
class DSCF_DSF_SupportForums_RecentPostsWidget extends WP_Widget {

    public static $displayOptions = array(
        1=>'count'
    );

    public function __construct() {
        // widget actual processes
        parent::__construct(
            'DSCF_DSF_SupportForums_RecentPostsWidget', // Base ID
            'Support Forums Recent Threads', // Name
            array( 'description' => __( 'Display recent Support Forum threads.', 'text_domain' ), ) // Args
        );
    }

    public function form( $instance ) {
        // outputs the options form on admin
        $count = 5;
        if ( $instance ) {
            $title = esc_attr( $instance['title'] );
            $count = $instance['count'];
        }
        else {
            $title = __( 'Recent Forum Threads' );
        }
        if(empty($count)){
            $count = 5;
        }

        ?>
        <p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label>
        <input class="widefat" id="<?=($this->get_field_id( 'title' ))?>" name="<?=($this->get_field_name( 'title' ))?>" type="text" value="<?=($title)?>" />
        </p>
        <p><?php _e( 'Number of forum threads to show:' ); ?><input type="text" id="<?=($this->get_field_id( 'count' ))?>" size="10" name="<?=($this->get_field_name( 'count' ))?>" value="<?=($count)?>" /></p>

    <?php
    }

    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        $title = (array_key_exists('title',$new_instance))?$new_instance['title']:"";
        $instance['title'] = strip_tags($title);

        $count = (array_key_exists('count',$new_instance))?$new_instance['count']:5;
        $instance['count'] = strip_tags($count);

        return $instance;
    }

    public function widget( $args, $instance ) {
        // outputs the content of the widget

        // Make sure the framework is enabled (this will prevent the widget from display entirely)
        if(!DSCF_DSF_Utilities::isPluginEnabled()){
            return;
        }

        // Now display the result based upon display id
        // Grabbing the html first -- so that we can just skip the display of the widget as a whole if there are problems
        $count = $instance['count'];
        if(empty($count)){
            $count = 5;
        }

        // Before the widget
        echo $args['before_widget'];

        // Title information
        if ( ! empty( $instance['title'] ) ) {
            echo $args['before_title'];
            echo esc_html( $instance['title'] );
            echo $args['after_title'];
        }

        // Html for List Display
        $pq = new WP_Query(array( 'post_type' => 'DSCF_DSF_thread', 'posts_per_page' => $count ));
        if( $pq->have_posts() ):
        ?>
            <div class="widget_recent_entries">
            <ul><?php while($pq->have_posts()) : $pq->the_post(); ?>
                <li><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></li>
                <?php
                wp_reset_query();
            endwhile;
                ?>
            </ul>
                </div>
<?php
        endif;

        // After the widget
        echo $args['after_widget'];

    }
}
