<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/31/15
 * Time: 10:01 AM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DSF_TagItem extends DSCF_DSF_StandardLinkRecord{

    const TABLE_NAME = 'tag-item';
    const COLUMN_A = 'itemId';
    const COLUMN_B = 'tagId';

    /*
	  *	Create a new link for a given Item ID and an Tag ID
	  */
    public function __construct($itemId, $tagId){
        return parent::__construct($itemId, $tagId);
    }

    /*
       *	Delete a single Item ID and Tag ID relationship
       */
    public static function deleteRelationship($itemId, $tagId){
        self::deleteSingleRelationship($itemId, $tagId);
    }

    /*
    *	Delete all links to a given Item ID
    */
    public static function deleteAllForItemId($id){
        self::deleteAllForColumn(self::COLUMN_A, $id);
    }

    /*
       *	Delete all links to a given Tag ID
       */
    public static function deleteAllForTagId($id){
        self::deleteAllForColumn(self::COLUMN_B, $id);
    }

    /*
       *	Get all Tag Ids linked to the given Item ID
       */
    public static function getAllForItemId($id){
        return self::getAllByForColumn(self::COLUMN_A, $id);
    }

    /*
       *	Get all Item Ids linked to the given Tag ID
       */
    public static function getAllForTagId($id){
        return self::getAllByForColumn(self::COLUMN_B, $id);
    }

    /*
       *	Get a count of all Tag Ids linked to the given Item ID
       */
    public static function getCountForItemId($id){
        return self::getCountForColumn(self::COLUMN_A, $id);
    }

    /*
       *	Get a count of all Item Ids linked to the given Tag ID
       */
    public static function getCountForTagId($id){
        return self::getCountForColumn(self::COLUMN_B, $id);
    }

}
