<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ben
 * Date: 3/12/15
 * Time: 11:26 PM
 * To change this template use File | Settings | File Templates.
 */
class DSCF_DSF_TagManager{

    // General Settings and Constants

    // Database Install Routine
    public static function installDatabase(){
        global $wpdb;

        // Get the DB CharSet
        $charset_collate = $wpdb->get_charset_collate();

        // Setup the Poll Question table
        $tag_table_name = DSCF_DSF_Tag::getTableName();
        $tag_item_table_name = DSCF_DSF_TagItem::getTableName();
        $sql = "
            CREATE TABLE $tag_table_name (
                id int(11) NOT NULL AUTO_INCREMENT,
                blogId BIGINT(20),
                typeId int(11) NOT NULL,
                data mediumblob,
                UNIQUE KEY id (id)
            ) $charset_collate;
            CREATE TABLE $tag_item_table_name (
                id int(11) unsigned NOT NULL AUTO_INCREMENT,
                blogId BIGINT(20),
                itemId int(11) NOT NULL,
                tagId int(11) NOT NULL,
                UNIQUE KEY id (id)
            ) $charset_collate;
            ";

        // Run the SQL
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
    }

    public static function shortcodeHandlerTag($atts){
        $html = "";
        $tag_id = 0;
        extract( shortcode_atts( array(
            'tag_id' => 0
        ), $atts ) );

        $tag = DSCF_DSF_Tag::get($tag_id);
        if(!empty($tag)){
            $html = $tag->getDisplayCode();
        }

        return $html;
    }

    public static function validateFreeTag(){
        global $_POST;
        $tags = DSCF_DSF_Tag::getAll();
        $tagId = null;
        foreach($tags as $tag){
            if(!empty($tagId)){
                DSCF_DSF_Tag::deleteById($tag->id);
            }else{
                $tagId = $tag->id;
            }
        }

        if(empty($tagId)){
            $tag = new DSCF_DSF_Tag();
            $tag->text = "Default Tag";
            $tag->save();
            $tagId = $tag->id;
        }

        if(empty($_REQUEST['id'])){
            $_REQUEST['id']=$tagId;
        }

        return $tagId;
    }

}
