<?php
/*
 * Plugin Name:   WPDevHub Support Forums
 * Version:       2.5
 * Plugin URI:    http://www.wpdevhub.com/
 * Description:   Manage a vibrant and feature rich support forum on your site
 * Author:        WPDevHub
 * Author URI:    http://www.wpdevhub.com/
 */

define('WPDEVHUB_CONST_DSF_PLUGIN_TITLE', 'WPDevHub Forums');
define('WPDEVHUB_CONST_DSF_APP_CODE', 'dsf');
define('WPDEVHUB_CONST_DSF_CLASSES_BROWSER', true);
define('WPDEVHUB_CONST_DSF_CLASSES_VIRTUAL_PAGES', true);
define('WPDEVHUB_CONST_DSF_CLASSES_METABOX', true);

// Standard Setup Steps
include dirname(__FILE__).'/inc/inc.setup.php';

// Class Includes
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_Main.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_RecentPostsWidget.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_CategoriesWidget.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_AddThreadButtonWidget.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_AddThreadFormWidget.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_Thread.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_Comment.php';
include dirname(__FILE__).'/classes/class.DSCF_DSF_SupportForums_CommentsMetaBox.php';

// Actions
add_action( 'init', array('DSCF_DSF_SupportForums_Main', 'wpActionInit'), 0 );

// Setup Virtual Pages
$controller = DSCF_DSF_VirtualPages_Controller::getController();
add_action( WPDEVHUB_CONST_DSF_SLUG.'_virtual_pages', function( $controller ) {

    $forumSlugBase = DSCF_DSF_SupportForums_Main::getSlugBase();

    /*
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/'.DSCF_DSF_SupportForums_Main::ADD_THREAD_SLUG.'/%%category_slug%%' ) )
        ->setTitle( 'Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Main', 'getVirtualPagesAddThreadForCategory') );
    */

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/'.DSCF_DSF_SupportForums_Main::ADD_THREAD_SLUG ) )
        ->setTitle( 'Support Forums - Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Main', 'getVirtualPagesAddThreadForCategory') );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/add-thread-handler/' ) )
        ->setTitle( 'Support Forums - Add Thread Handler' )
        ->setTemplate( 'pages/wpdevhub-dsf-vp-add-thread-submit.php' );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/add-comment-handler/' ) )
        ->setTitle( 'Support Forums - Add Comment Handler' )
        ->setTemplate( 'pages/wpdevhub-dsf-vp-add-comment-submit.php' );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/add-content-confirmation/' ) )
        ->setTitle( 'Support Forums - Add Thread Confirmation' )
        ->setCallback( array('DSCF_DSF_SupportForums_Main', 'getVirtualPagesAddContentConfirmation') );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/error/%%error_code%%' ) )
        ->setTitle( 'Support Forums - Error Page' )
        ->setCallback( array('DSCF_DSF_SupportForums_Main', 'getVirtualPagesErrorHandler') );

    // Doing this otherwise it uses the built in list display
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/thread' ) )
        ->setTitle( 'Support Forums' )
        ->setCallback( array('DSCF_DSF_SupportForums_Main', 'redirectHome') );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase ) )
        ->setTitle( 'Support Forums' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesForumHome') );

    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase . '/page/%%page%%' ) )
        ->setTitle( 'Support Forums' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesForumHome') );

    /*
    // List of threads for a category
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/category/%%category_slug%%' ) )
        ->setTitle( 'Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesPostList') );

    // List of threads for a category
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/category/%%category_slug%%/page/%%page%%' ) )
        ->setTitle( 'Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesForumThreadListForTerm') );

    // List of threads for a tag
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/tag/%%tag_slug%%' ) )
        ->setTitle( 'Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesForumThreadListForTerm') );

    // List of threads for a tag
    $controller->addPage( new DSCF_DSF_VirtualPages_Page( $forumSlugBase.'/tag/%%tag_slug%%/page/%%page%%' ) )
        ->setTitle( 'Add Thread' )
        ->setCallback( array('DSCF_DSF_SupportForums_Thread', 'getVirtualPagesForumThreadListForTerm') );
    */

} );
